//+------------------------------------------------------------------+
//|                                             ay-iBetterVolume.mqh |
//|                                                            v1.10 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
#define IDX_CH    0
#define IDX_CL    1
#define IDX_HC    2
#define IDX_CC    3
#define IDX_LV    4
#define IDX_H2P   5
#define IDX_L2P   6   
#define IDX_NV    7

int identifyVolume(int tf, int shift, int lookback)
{
  
   double  dVolLowest
         , dRange                   //--iHigh(NULL, tf, shift)-iVolume(NULL, tf, shift)
         , dVMbR                    //--iVolume(NULL, tf, shift)*dRange
         , dVDbR                    //--iVolume(NULL, tf, shift)/dRange         
         , dHiVMbR                  //--Highest Volome, highest dVMbR in lookback period
         , dHiVDbR                  //--Highest Volume, highest dVDbR in lookback period
         , dLoVDbR = 999999999.9999 //--Lowest Volume, lowest of volume divide by its Range in lookback period
         , dVol                     //--bar's volume         
         , adVMbR[]                 //--array of volume multipy by its range
         , adVDbR[]                 //--array of volume divide by its Range         
         ;                  

   int     i, j;
   
   double  high0  = iHigh  (NULL, tf, shift)
         , low0   = iLow   (NULL, tf, shift)
         , close0 = iClose (NULL, tf, shift)
         , vol0   = iVolume(NULL, tf, shift)
         , vol1   = iVolume(NULL, tf, shift + 1)
         , vol2   = iVolume(NULL, tf, shift + 2)
    ;

   dRange = high0 - low0;        
   
   bool    bCloseAbove50Percent = close0 >  (low0 + 0.5*dRange)
         , bCloseBelow50Percent = close0 <= (low0 + 0.5*dRange)         
         , bVolHigherThan2Prev  = vol0 > vol1 && vol0 > vol2         
         , bVolLowerThan2Prev   = vol0 < vol1 && vol0 < vol2
         ;
                     
   dVolLowest = iVolume(NULL, tf, iLowest(NULL, tf, MODE_VOLUME, lookback, shift));       
   dVMbR      = iVolume(NULL, tf, shift)*dRange;
   
   //-->dVDbR
   if (  dRange != 0 ) dVDbR = iVolume(NULL, tf, shift)/dRange;
   //<--dVDbR      
   
   //-->Calculate dHiVMbR, dHiVDbR, dLoVDbR 
   ArrayResize(adVMbR, lookback);
   ArrayResize(adVDbR, lookback);
   ArrayInitialize(adVMbR, 0.0);
   ArrayInitialize(adVDbR, 0.0);

   for ( i=shift, j=0; i<shift+lookback; i++, j++)
   {
      dVol   = iVolume(NULL, tf, i);
      dRange = iHigh(NULL, tf, i) - iLow(NULL, tf, i);
      
      adVMbR[j] = dVol*dRange;  
           
      if ( adVMbR[j] != 0 ) adVDbR[j] = dVol / dRange;                
   }
   
   dHiVMbR = adVMbR[ArrayMaximum(adVMbR)];
   dHiVDbR = adVDbR[ArrayMaximum(adVDbR)];
   dLoVDbR = adVDbR[ArrayMinimum(adVDbR)];
   //<--Calculate dHiVMbR, dHiVDbR, dLoVDbR     
   
        //--ClimaxChurn 
   if ( dVMbR == dHiVMbR && dVDbR == dHiVDbR )       return(IDX_CC);   
   else //--ClimaxHigh                          
   if ( dVMbR == dHiVMbR  && bCloseAbove50Percent )  return(IDX_CH);   
   else //--HighChurn 
   if ( dVDbR == dHiVDbR )                           return(IDX_HC);
   else //--ClimaxLow
   if ( dVMbR == dHiVMbR  && bCloseBelow50Percent )  return(IDX_CL);
   else //--Lowest Volume    
   if ( iVolume(NULL, tf, shift) == dVolLowest )     return(IDX_LV);
   else //--Volume is higher than prev 2 bars
   if ( bVolHigherThan2Prev )                        return(IDX_H2P);
   else //--Volume is lower than prev 2 bars
   if ( bVolLowerThan2Prev )                         return(IDX_L2P);   
   else //--default result: neutral
                                                     return(IDX_NV);   
}